#include <iostream>
#include <vector>
#include "histogram.h"
#include "svg.h"

using namespace std;

struct Input
{
    vector<double> numbers;
    size_t bin_count{};
};

Input
input_data(istream& stream)
{
    size_t number_count;
    cerr << "Enter number count: ";
    stream >> number_count;
    Input in;
    in.numbers.resize(number_count);
    for (size_t i = 0; i < number_count; i++)
    {
        stream >> in.numbers[i];
    }
    cerr << "Enter bin count: ";
    stream >> in.bin_count;
    return in;
}

int main()
{
    Input in = input_data(cin);
    vector<size_t> bins = make_histogram(in.numbers, in.bin_count);
    show_histogram_svg(bins);
}
