#define DOCTEST_CONFIG_NO_MULTITHREADING
#define DOCTEST_CONFIG_IMPLEMENT_WITH_MAIN
#include "doctest.h"
#include "histogram_internal.h"

TEST_CASE("distinct positive numbers") {
    double min = 0;
    double max = 0;
    bool empty_vector = false;
    find_minmax({1, 2}, min, max, empty_vector);
    CHECK(empty_vector == false);
    CHECK(min == 1);
    CHECK(max == 2);
}

TEST_CASE("the only number") {
    double min = 0;
    double max = 0;
    bool empty_vector = false;
    find_minmax({1}, min, max, empty_vector);
    CHECK(empty_vector == false);
    CHECK(min == 1);
    CHECK(max == 1);
}

TEST_CASE("negative numbers") {
    double min = 0;
    double max = 0;
    bool empty_vector = false;
    find_minmax({-1, -2}, min, max, empty_vector);
    CHECK(empty_vector == false);
    CHECK(min == -2);
    CHECK(max == -1);
}

TEST_CASE("identical numbers") {
    double min = 0;
    double max = 0;
    bool empty_vector = false;
    find_minmax({2, 2}, min, max, empty_vector);
    CHECK(empty_vector == false);
    CHECK(min == 2);
    CHECK(max == 2);
}

TEST_CASE("empty vector") {
    double min = 0;
    double max = 0;
    bool empty_vector = false;
    find_minmax({}, min, max, empty_vector);
    CHECK(empty_vector == true);
    CHECK(min == 0);
    CHECK(max == 0);
}
